/****
 *
 * Exemplo: Arredondamentos
 *
 * Seo: D.12.1
 *
 * Baseado em: U. W. Kulish and W. L. Miranker.
 *             "The Arithmetic of the Digital Computer:
 *             A New Approach". SIAM Review, 28(1):1-40,
 *             March 1986.
 *
 ****/

#include <stdio.h>
#include <math.h>

int main(void)
{
   double x;

      /* O valor atribudo a x certamente ser zero */
   x = pow(10, 40) +
       700         -
       pow(10, 40) +
       pow(10, 45) +
       500         -
       pow(10, 45);

   printf("\nPrimeira expressao:\n\tValor de x = %f\n", x);

      /* Alterando-se a ordem das parcelas pode-se */
      /* obter o resultado correto. Por exemplo:   */

   x = pow(10, 40) -
       pow(10, 40) +
       pow(10, 45) -
       pow(10, 45) +
       700         +
       500;

   printf("\nSegunda expressao:\n\tValor de x = %f\n", x);

   return 0;
}

/******************* Exemplo de Execuo ******************

Primeira expressao:
        Valor de x = 0.000000

Segunda expressao:
        Valor de x = 1200.00000

**********************************************************/
