/****
 *
 * Exemplo: Arredondamentos
 *
 * Seo: D.12.1
 *
 * Baseado em: U. W. Kulish and W. L. Miranker.
 *             "The Arithmetic of the Digital Computer:
 *             A New Approach". SIAM Review, 28(1):1-40,
 *             March 1986.
 *
 ****/

#include <stdio.h>
#include <math.h>

int main(void)
{
   double x, y;

      /* O valor atribudo a x certamente ser zero */
   x = pow(10, 40) +
       700         -
       pow(10, 40) +
       pow(10, 45) +
       500         -
       pow(10, 45);

      /* Alterando-se a ordem das parcelas  */
      /* pode-se obter o resultado correto: */
   y = pow(10, 40) -
       pow(10, 40) +
       pow(10, 45) -
       pow(10, 45) +
       700         +
       500;

   printf("\nErro absoluto: %e", y - x);
   printf("\nErro relativo: %e\n", (y - x)/pow(10, 45));

   return 0;
}

/******************* Exemplo de Execuo ******************

Erro absoluto: 1.200000e+003
Erro relativo: 1.200000e-042

**********************************************************/
