/****
 *
 * Exemplo: assignment makes integer from pointer without
 *          a cast
 *
 * Seo: D.19.20
 *
 ****/

#include <stdio.h>

void Troca(int *p1, int *p2)
{
   int aux = p1; /* Errado: deveria ser 'aux = *p1' */

   *p1 = *p2;
   *p2 = aux;
}

int main(void)
{
   int i = 2, j = 3;

   printf( "\n\t>>> ANTES da troca <<<\n"
           "\n\t    i = %d, j = %d\n", i, j );

   Troca(&i, &j);

   printf( "\n\t>>> DEPOIS da troca <<<\n"
           "\n\t    i = %d, j = %d\n", i, j );

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: initialization makes integer from pointer without
         a cast

***********************************************************/
/******************* Exemplo de Execuo *******************

        >>> ANTES da troca <<<

            i = 2, j = 3

        >>> DEPOIS da troca <<<

            i = 3, j = 2293580

***********************************************************/
