/****
 *
 * Exemplo: Uso de fseek() com Arquivos de Texto
 *
 * Seo: D.6.12
 *
 ****/

#include <stdio.h>

int main(void)
{
   FILE *stream;
   int   i;

   if(!(stream = fopen("Teste", "w+"))) {
      printf("Arquivo nao foi criado\n");
      return 1;
   }

   for (i = '0'; i <= '9'; ++i) {
      fprintf(stream, "%c\n", i);
   }

   if (fseek(stream, 3, SEEK_SET)) {
      printf("Indicador de posicao nao foi movido\n");
      return 1;
   }

   putchar(fgetc(stream));

   fclose(stream);

   return 0;
}

/****************** Resultados do Programa *****************

Windows XP
==========

1

Mac OS X
========

[Quebra de linha]

***********************************************************/
