/****
 *
 * Exemplo: control reaches end of non-void function
 *
 * Seo: D.19.11
 *
 ****/

#include <stdio.h>

int Soma(int x, int y)
{
   int soma;

   soma = x + y;
}

int main(void)
{
   int x, y;

   printf("Digite dois valores inteiros: ");
   scanf("%d %d", &x, &y);

   x = x + y;

   printf("Soma: %d + %d = %d\n", x, y, Soma(x, y));

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: variable 'soma' set but not used
warning: control reaches end of non-void function

***********************************************************/
/******************* Exemplo de Execuo *******************

Digite um valor inteiro: 35

Voce digitou: 2147315712

***********************************************************/

