/****
 *
 * Exemplo: return makes integer from pointer without a cast
 *
 * Seo: D.19.17
 *
 ****/

#include <stdio.h>
#include <stdlib.h>

int F(void)
{
   int *p = malloc(sizeof(int));

   *p = 5;

   return p;
}

int main(void)
{
   int i;

   i = F();

   printf("\ni = %d\n", i);

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: return makes integer from pointer without a cast

***********************************************************/
/******************* Exemplo de Execuo *******************

i = 4072528

***********************************************************/
