/****
 *
 * Exemplo: assignment (initialization) discards 'const'
 *          qualifier from pointer target type
 *
 * Seo: D.19.22
 *
 ****/

#include <stdio.h>

int main(void)
{
   const int varConstante = 0;
   int      *ptr;

   ptr = &varConstante;

   *ptr = 1;

   printf("\nvarConstante = %d\n", varConstante);

   return 0;
}

/****************** Exemplo de Compilao ******************

warning: assignment discards 'const' qualifier from pointer
target type

***********************************************************/
/****************** Resultado do Programa ******************

varConstante = 1

***********************************************************/
